/*!
 * cronicle-task-backup 0.0.1
 * Copyright(c) 2019 Javanile
 * MIT Licensed
 */

const fs = require('fs')
    , cc = require('javanile-cronicle-client');

module.exports = {
    /**
     * Apply shell script to event and run.
     *
     * @param app
     * @param facts
     * @param args
     * @param value
     */
    apply(app, host, facts, args, value) {
        const client = new cc.CronicleClient(host);

        const apply = (data) => {
            let id = data.id || data.event.id;
            //let script = JSON.stringify()
            let req = {
                id: id,
                plugin: 'shellplug',
                params: {
                    script: fs.readFileSync(value).toString()
                }
            };

            client.updateEvent(req).then((data) => {
                client.runEvent({
                    id: id
                }).then((data) => {
                    setTimeout(() => {
                        client.getJobLog({
                            id: data.ids[0]
                        }).then((data) => {
                            console.log("FINALE:", data);
                        }).catch((err) => {
                            console.log(`Cronicle task: ${err.message}`);
                        });
                    }, 10000);
                }).catch((err) => {
                    console.log(`Cronicle task: ${err.message}`);
                });
            }).catch((err) => {
                console.log(`Cronicle task: ${err.message}`);
            });
        };

        client.getEvent({
            title: facts.event
        }).then(apply).catch((err) => {
            if (err.code !== 'event') {
                app.error(err.message);
            }
            client.getEvent({
                id: facts.event
            }).then(apply).catch((err) => {
                if (err.code !== 'event') {
                    app.error(err.message);
                }
                client.createEvent({
                    title: facts.event,
                    enabled: 1,
                    category: 'general',
                    target: 'allgrp',
                    plugin: 'shellplug'
                }).then(apply).catch((err) => {
                    app.error(err.message);
                });
            });
        });
    }
};
